import { HttpHeaders, HttpParams } from '@angular/common/http';
import { AuthProvider, AuthSignInResponse } from './interfaces/provider.interface';
import { Observable } from 'rxjs';
import { AuthSession } from './auth.session';
import * as i0 from "@angular/core";
export declare class Auth {
    private readonly _storage;
    private readonly _injector;
    private readonly _platform;
    private readonly _httpClient;
    private readonly _state?;
    private readonly _config?;
    private readonly _httpConfig?;
    private readonly _handler?;
    private readonly _authStateKey;
    private readonly _httpAlias;
    readonly session: AuthSession;
    readonly user: Observable<any | null>;
    private _refreshHandler;
    constructor();
    initialize(): () => Promise<void>;
    me<T = any>(): Observable<T>;
    signIn(provider: AuthProvider, as?: string[]): Promise<AuthSignInResponse>;
    signInWithEmail(email: string, password: string, as?: string[]): Promise<AuthSignInResponse>;
    signInWithVerifyCode(code: string, verifyToken: string): Promise<AuthSignInResponse>;
    resendVerifyCode(verifyToken: string): Promise<Object>;
    register<T = any>(data: any, options?: {
        headers?: HttpHeaders | {
            [header: string]: string | string[];
        };
        params?: HttpParams | {
            [param: string]: string | number | boolean | ReadonlyArray<string | number | boolean>;
        };
    }): Promise<T>;
    logout(): void;
    refresh(): Observable<string>;
    requestPassword(email: string, extraParams?: {
        [key: string]: any;
    }): Promise<Object>;
    resetPassword(token: string, newPassword: string, extraParams?: {
        [key: string]: any;
    }): Promise<Object>;
    clearAndRedirect(): void;
    private setTokens;
    private handleAutoRefreshing;
    private autoRefresh;
    private get router();
    private getUrl;
    static ɵfac: i0.ɵɵFactoryDeclaration<Auth, never>;
    static ɵprov: i0.ɵɵInjectableDeclaration<Auth>;
}
