import { ArrayCollectionStringKeys } from '../interfaces/array-collection.interface';
import { CollectionRequestSort } from '../interfaces/collection.interface';
export declare class ArrayCollection<T> {
    protected value: T[];
    constructor(value: T[]);
    search(query: string, fields: ArrayCollectionStringKeys<T>[]): this;
    sortBy(sort: CollectionRequestSort<keyof T> | CollectionRequestSort<keyof T>[], sortables: Partial<Record<ArrayCollectionStringKeys<T>, 'string' | 'number'>>): this;
    toPage(pageNumber: number, pageSize: number): {
        totalPages: number;
        totalEntries: number;
        pageSize: number;
        pageNumber: number;
        data: T[];
    };
    toArray(): T[];
    protected normalizeValueAsString(value: unknown): string;
}
