export interface CollectionRequest {
    pageNumber: number;
    pageSize: number;
    query: string | null;
    queryFields: string[];
    sort: CollectionRequestSort | CollectionRequestSort[];
}
export interface CollectionRequestSort<T = string> {
    name: T;
    direction: 'asc' | 'desc';
}
export interface CollectionData<T> {
    pageNumber: number;
    pageSize: number;
    totalPages: number;
    totalEntries: number;
    data: T[];
    raw?: any;
}
export interface CollectionApiResponse<T> {
    page_number: number;
    page_size: number;
    total_pages: number;
    total_entries: number;
    data: T[];
    [key: string]: unknown;
}
export type CollectionApiParams = string | number | boolean | ReadonlyArray<string | number | boolean>;
