import { ChangeDetectorRef, EventEmitter, OnDestroy, OnInit, TemplateRef } from '@angular/core';
import { ControlValueAccessor, FormControl, FormGroup } from '@angular/forms';
import { BehaviorSubject, Observable } from 'rxjs';
import * as i0 from "@angular/core";
export declare class BbDatePicker implements ControlValueAccessor, OnInit, OnDestroy {
    private _changeDetectorRef;
    private _localizeId;
    readonly _yearRegex: RegExp;
    label: string | TemplateRef<any> | null;
    hint: string | TemplateRef<any> | null;
    dayPlaceholder: string | null;
    monthPlaceholder: string | null;
    yearPlaceholder: string | null;
    required: boolean;
    grouped: boolean;
    readonly: boolean;
    hideErrors: boolean;
    set disabled(value: boolean);
    get disabled(): boolean;
    set years(value: [string | number, string | number] | null);
    form: FormGroup;
    data$: Observable<{
        days?: {
            label: string;
            value: number;
        }[];
        months?: {
            label: string;
            value: number;
        }[];
        years?: number[] | null;
    }>;
    years$: BehaviorSubject<number[]>;
    get value(): string | null;
    set value(value: string | null);
    valueChange: EventEmitter<string>;
    error: boolean;
    private _disabled;
    onTouchedCallback: () => void;
    onChangeCallback: (_: string | null) => void;
    private _subscription;
    constructor(_changeDetectorRef: ChangeDetectorRef, _localizeId: Observable<string>);
    ngOnInit(): void;
    ngOnDestroy(): void;
    writeValue(value: string | null): void;
    registerOnChange(method: (_: string | null) => void): void;
    registerOnTouched(method: () => void): void;
    setDisabledState(isDisabled: boolean): void;
    onErrorChange(error: {
        token: string;
        data?: any;
    } | null): void;
    validate({ value }: FormControl<string>): {
        invalidDate: boolean;
    };
    private handleChanges;
    private getData;
    private verifyListData;
    private getDayData;
    private getMonthData;
    private composeForm;
    private parseDateStringInForm;
    private parseDateString;
    private parseYears;
    private formToDateString;
    private parseYearFormat;
    private getDaysInMonth;
    private isValidDateString;
    private padString;
    static ɵfac: i0.ɵɵFactoryDeclaration<BbDatePicker, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<BbDatePicker, "bb-date-picker", never, { "label": { "alias": "label"; "required": false; }; "hint": { "alias": "hint"; "required": false; }; "dayPlaceholder": { "alias": "dayPlaceholder"; "required": false; }; "monthPlaceholder": { "alias": "monthPlaceholder"; "required": false; }; "yearPlaceholder": { "alias": "yearPlaceholder"; "required": false; }; "required": { "alias": "required"; "required": false; }; "grouped": { "alias": "grouped"; "required": false; }; "readonly": { "alias": "readonly"; "required": false; }; "hideErrors": { "alias": "hideErrors"; "required": false; }; "disabled": { "alias": "disabled"; "required": false; }; "years": { "alias": "years"; "required": false; }; "value": { "alias": "value"; "required": false; }; }, { "valueChange": "valueChange"; }, never, never, true, never>;
    static ngAcceptInputType_required: unknown;
    static ngAcceptInputType_grouped: unknown;
    static ngAcceptInputType_readonly: unknown;
    static ngAcceptInputType_hideErrors: unknown;
    static ngAcceptInputType_disabled: unknown;
}
