import { EventEmitter, OnInit } from '@angular/core';
import { BbExtraErrorControls } from '../directives/extra-error-controls.directive';
import { BbFormSubmitter } from '../directives/form-submitter.directive';
import { ElementsError } from '../elements.interfaces';
import { BbFormSubmit } from '../directives/form-submit.directive';
import { NgControl } from '@angular/forms';
import { Observable } from 'rxjs';
import * as i0 from "@angular/core";
export declare class BbFormError implements OnInit {
    private _form?;
    private _ngControl?;
    private _formSubmitter?;
    private _extraErrorControls?;
    private _errors?;
    readonly errorsMap: ElementsError;
    control: NgControl | null;
    errorChange: EventEmitter<{
        token: string;
        data?: any;
    }>;
    error$: Observable<{
        token: string;
        data?: any;
    } | null>;
    constructor(_form?: BbFormSubmit, _ngControl?: NgControl, _formSubmitter?: BbFormSubmitter, _extraErrorControls?: BbExtraErrorControls, _errors?: ElementsError[]);
    ngOnInit(): void;
    private setControl;
    private setError;
    private formatError;
    private submitStatusChanges;
    private getNativeFormSubmit;
    private getManualFormSubmit;
    private getErrors;
    static ɵfac: i0.ɵɵFactoryDeclaration<BbFormError, [{ optional: true; }, { optional: true; }, { optional: true; }, { optional: true; }, { optional: true; }]>;
    static ɵcmp: i0.ɵɵComponentDeclaration<BbFormError, "bb-form-error", never, { "control": { "alias": "control"; "required": false; }; }, { "errorChange": "errorChange"; }, never, never, true, never>;
}
