import { ChangeDetectorRef, ElementRef, EventEmitter, TemplateRef } from '@angular/core';
import { ControlValueAccessor, FormControl } from '@angular/forms';
import { Files } from '@bravobit/bb-foundation';
import * as i0 from "@angular/core";
export declare class BbMultiFileControl implements ControlValueAccessor {
    private _files;
    private _changeDetectorRef;
    readonly labelId: string;
    fileInput: ElementRef<HTMLInputElement>;
    label: string | TemplateRef<any> | null;
    hint: string | TemplateRef<any> | null;
    accept: string | null;
    grouped: boolean;
    required: boolean;
    disabled: boolean;
    hideErrors: boolean;
    items: {
        id: number;
        label: string;
        url: string;
    }[];
    delete: EventEmitter<{
        id: number;
        label: string;
        url: string;
    }>;
    value: File[];
    error: boolean;
    onTouchedCallback: () => void;
    onChangeCallback: (_: File[] | null) => void;
    constructor(_files: Files, _changeDetectorRef: ChangeDetectorRef);
    get showList(): boolean;
    downloadFile(file: File): void;
    openFileDialog(): void;
    onFileChange(event: Event): void;
    deleteFile(index: number): void;
    writeValue(value: File[] | null): void;
    registerOnChange(method: (_: File[] | null) => void): void;
    registerOnTouched(method: () => void): void;
    setDisabledState(isDisabled: boolean): void;
    onErrorChange(error: {
        token: string;
        data?: any;
    } | null): void;
    validate({ value }: FormControl<File[]>): {
        invalidFiles: Record<number, boolean>;
    };
    addFiles(files: File[]): void;
    private isFileLike;
    static ɵfac: i0.ɵɵFactoryDeclaration<BbMultiFileControl, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<BbMultiFileControl, "bb-multi-file-control", never, { "label": { "alias": "label"; "required": false; }; "hint": { "alias": "hint"; "required": false; }; "accept": { "alias": "accept"; "required": false; }; "grouped": { "alias": "grouped"; "required": false; }; "required": { "alias": "required"; "required": false; }; "disabled": { "alias": "disabled"; "required": false; }; "hideErrors": { "alias": "hideErrors"; "required": false; }; "items": { "alias": "items"; "required": false; }; }, { "delete": "delete"; }, never, never, true, never>;
    static ngAcceptInputType_grouped: unknown;
    static ngAcceptInputType_required: unknown;
    static ngAcceptInputType_disabled: unknown;
    static ngAcceptInputType_hideErrors: unknown;
}
