import * as i0 from '@angular/core';
import { Directive, EventEmitter, booleanAttribute, numberAttribute, forwardRef, TemplateRef, Component, ChangeDetectionStrategy, ViewEncapsulation, ContentChild, ViewChild, Input, Output, makeEnvironmentProviders, NgModule } from '@angular/core';
import { NgSelectComponent, NgOptionTemplateDirective, NgLabelTemplateDirective, NgMultiLabelTemplateDirective, NgOptgroupTemplateDirective, SELECTION_MODEL_FACTORY, DefaultSelectionModelFactory } from '@ng-select/ng-select';
import * as i1 from '@angular/forms';
import { FormControl, NG_VALUE_ACCESSOR, ReactiveFormsModule } from '@angular/forms';
import { BbFormError } from '@bravobit/bb-foundation/elements';
import { AsyncPipe, NgTemplateOutlet } from '@angular/common';
import { observableAttribute } from '@bravobit/bb-foundation';
import { BbLocalize } from '@bravobit/bb-foundation/localize';
import { BbTemplate } from '@bravobit/bb-foundation/utils';
import { Subscription } from 'rxjs';

class BbSelectOptionGroup {
    template;
    constructor(template) {
        this.template = template;
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "18.2.8", ngImport: i0, type: BbSelectOptionGroup, deps: [{ token: i0.TemplateRef }], target: i0.ɵɵFactoryTarget.Directive });
    static ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "14.0.0", version: "18.2.8", type: BbSelectOptionGroup, isStandalone: true, selector: "ng-template[bbSelectOptionGroup]", ngImport: i0 });
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "18.2.8", ngImport: i0, type: BbSelectOptionGroup, decorators: [{
            type: Directive,
            args: [{
                    selector: 'ng-template[bbSelectOptionGroup]',
                    standalone: true
                }]
        }], ctorParameters: () => [{ type: i0.TemplateRef }] });

class BbSelectMultiLabel {
    template;
    constructor(template) {
        this.template = template;
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "18.2.8", ngImport: i0, type: BbSelectMultiLabel, deps: [{ token: i0.TemplateRef }], target: i0.ɵɵFactoryTarget.Directive });
    static ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "14.0.0", version: "18.2.8", type: BbSelectMultiLabel, isStandalone: true, selector: "ng-template[bbSelectMultiLabel]", ngImport: i0 });
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "18.2.8", ngImport: i0, type: BbSelectMultiLabel, decorators: [{
            type: Directive,
            args: [{
                    selector: 'ng-template[bbSelectMultiLabel]',
                    standalone: true
                }]
        }], ctorParameters: () => [{ type: i0.TemplateRef }] });

class BbSelectOption {
    template;
    constructor(template) {
        this.template = template;
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "18.2.8", ngImport: i0, type: BbSelectOption, deps: [{ token: i0.TemplateRef }], target: i0.ɵɵFactoryTarget.Directive });
    static ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "14.0.0", version: "18.2.8", type: BbSelectOption, isStandalone: true, selector: "ng-template[bbSelectOption]", ngImport: i0 });
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "18.2.8", ngImport: i0, type: BbSelectOption, decorators: [{
            type: Directive,
            args: [{
                    selector: 'ng-template[bbSelectOption]',
                    standalone: true
                }]
        }], ctorParameters: () => [{ type: i0.TemplateRef }] });

class BbSelectLabel {
    template;
    constructor(template) {
        this.template = template;
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "18.2.8", ngImport: i0, type: BbSelectLabel, deps: [{ token: i0.TemplateRef }], target: i0.ɵɵFactoryTarget.Directive });
    static ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "14.0.0", version: "18.2.8", type: BbSelectLabel, isStandalone: true, selector: "ng-template[bbSelectLabel]", ngImport: i0 });
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "18.2.8", ngImport: i0, type: BbSelectLabel, decorators: [{
            type: Directive,
            args: [{
                    selector: 'ng-template[bbSelectLabel]',
                    standalone: true
                }]
        }], ctorParameters: () => [{ type: i0.TemplateRef }] });

let nextUniqueId = 0;
class BbSelect {
    // Readonly data.
    labelId = `bb-select-${nextUniqueId++}`;
    control = new FormControl();
    // Content children.
    optionTemplate;
    optionGroupTemplate;
    labelTemplate;
    multiLabelTemplate;
    // View children.
    selectComponent;
    // Inputs.
    label = null;
    hint = null;
    data = null;
    required = false;
    readonly = false;
    grouped = false;
    hideErrors = false;
    loading = false;
    multiple = false;
    clearable = true;
    searchable = true;
    virtualScroll = true;
    closeOnSelect = true;
    selectableGroup = false;
    selectableGroupAsModel = false;
    hideArrow = false;
    selectOnTab = false;
    hideSelected = false;
    maxSelectedItems = null;
    bindLabel = null;
    bindValue = null;
    placeholder = null;
    typeahead = null;
    trackByFn = null;
    groupBy = null;
    isOpen = null;
    clearSearchOnAdd = null;
    addTag = false;
    appendTo = 'body';
    set disabled(value) {
        this._disabled = value;
        this._disabled ? this.control?.disable() : this.control?.enable();
    }
    get disabled() {
        return this._disabled;
    }
    get value() {
        return this.control.value;
    }
    valueChange = new EventEmitter();
    onBlur = new EventEmitter();
    onChange = new EventEmitter();
    set value(value) {
        this.control.setValue(value);
        this.valueChange.emit(value);
    }
    // State.
    error = false;
    _disabled = false;
    // Callbacks.
    onTouchedCallback = () => ({});
    onChangeCallback = () => ({});
    // Subscriptions.
    _subscription = new Subscription();
    ngOnInit() {
        this.handleValueChanges();
    }
    ngOnDestroy() {
        this._subscription?.unsubscribe();
    }
    writeValue(value) {
        this.control.patchValue(value, { emitEvent: false });
    }
    registerOnChange(method) {
        this.onChangeCallback = method;
    }
    registerOnTouched(method) {
        this.onTouchedCallback = method;
    }
    setDisabledState(isDisabled) {
        this.disabled = isDisabled;
    }
    onErrorChange(error) {
        this.error = !!error;
    }
    handleValueChanges() {
        const subscription = this.control.valueChanges
            .subscribe(value => this.onChangeCallback?.(value));
        this._subscription.add(subscription);
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "18.2.8", ngImport: i0, type: BbSelect, deps: [], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "17.0.0", version: "18.2.8", type: BbSelect, isStandalone: true, selector: "bb-select", inputs: { label: "label", hint: "hint", data: ["data", "data", observableAttribute], required: ["required", "required", booleanAttribute], readonly: ["readonly", "readonly", booleanAttribute], grouped: ["grouped", "grouped", booleanAttribute], hideErrors: ["hideErrors", "hideErrors", booleanAttribute], loading: ["loading", "loading", booleanAttribute], multiple: ["multiple", "multiple", booleanAttribute], clearable: ["clearable", "clearable", booleanAttribute], searchable: ["searchable", "searchable", booleanAttribute], virtualScroll: ["virtualScroll", "virtualScroll", booleanAttribute], closeOnSelect: ["closeOnSelect", "closeOnSelect", booleanAttribute], selectableGroup: ["selectableGroup", "selectableGroup", booleanAttribute], selectableGroupAsModel: ["selectableGroupAsModel", "selectableGroupAsModel", booleanAttribute], hideArrow: ["hideArrow", "hideArrow", booleanAttribute], selectOnTab: ["selectOnTab", "selectOnTab", booleanAttribute], hideSelected: ["hideSelected", "hideSelected", booleanAttribute], maxSelectedItems: ["maxSelectedItems", "maxSelectedItems", numberAttribute], bindLabel: "bindLabel", bindValue: "bindValue", placeholder: "placeholder", typeahead: "typeahead", trackByFn: "trackByFn", groupBy: "groupBy", isOpen: "isOpen", clearSearchOnAdd: "clearSearchOnAdd", addTag: "addTag", appendTo: "appendTo", disabled: ["disabled", "disabled", booleanAttribute], value: "value" }, outputs: { valueChange: "valueChange", onBlur: "onBlur", onChange: "onChange" }, host: { properties: { "class.required": "required", "class.readonly": "readonly", "class.disabled": "disabled", "class.grouped": "grouped", "class.error": "error", "class.hide-arrow": "hideArrow" }, classAttribute: "bb-select" }, providers: [{
                provide: NG_VALUE_ACCESSOR,
                useExisting: forwardRef(() => BbSelect),
                multi: true
            }], queries: [{ propertyName: "optionTemplate", first: true, predicate: BbSelectOption, descendants: true, read: TemplateRef }, { propertyName: "optionGroupTemplate", first: true, predicate: BbSelectOptionGroup, descendants: true, read: TemplateRef }, { propertyName: "labelTemplate", first: true, predicate: BbSelectLabel, descendants: true, read: TemplateRef }, { propertyName: "multiLabelTemplate", first: true, predicate: BbSelectMultiLabel, descendants: true, read: TemplateRef }], viewQueries: [{ propertyName: "selectComponent", first: true, predicate: NgSelectComponent, descendants: true, static: true }], ngImport: i0, template: "<!-- Label of the form control. -->\n@if (label; as labelContent) {\n    <label [attr.for]=\"labelId\"\n           class=\"bb-select-label\">\n        <ng-template [bbTemplate]=\"labelContent\">{{ labelContent }}</ng-template>\n    </label>\n}\n\n<ng-select [formControl]=\"control\"\n           [notFoundText]=\"'select.not_found_text' | bbLocalize\"\n           [clearAllText]=\"'select.clear_all_text' | bbLocalize\"\n           [loadingText]=\"'select.loading_text' | bbLocalize\"\n           [typeToSearchText]=\"'select.type_to_search_text' | bbLocalize\"\n           [addTagText]=\"'select.add_tag_text' | bbLocalize\"\n           [virtualScroll]=\"virtualScroll\"\n           [items]=\"data | async\"\n           [multiple]=\"multiple\"\n           [loading]=\"loading\"\n           [labelForId]=\"labelId\"\n           [searchable]=\"searchable\"\n           [placeholder]=\"placeholder\"\n           [clearable]=\"clearable\"\n           [closeOnSelect]=\"closeOnSelect\"\n           [trackByFn]=\"trackByFn\"\n           [typeahead]=\"typeahead\"\n           [bindLabel]=\"bindLabel\"\n           [bindValue]=\"bindValue\"\n           [selectableGroup]=\"selectableGroup\"\n           [selectableGroupAsModel]=\"selectableGroupAsModel\"\n           [clearSearchOnAdd]=\"clearSearchOnAdd\"\n           [hideSelected]=\"hideSelected\"\n           [maxSelectedItems]=\"maxSelectedItems\"\n           [groupBy]=\"groupBy\"\n           [isOpen]=\"isOpen\"\n           [readonly]=\"readonly\"\n           [addTag]=\"addTag\"\n           [appendTo]=\"appendTo\"\n           (blur)=\"onBlur?.emit($event)\"\n           (change)=\"onChange?.emit($event)\">\n    @if (optionTemplate) {\n        <ng-template ng-option-tmp\n                     let-item=\"item\"\n                     let-item$=\"item$\"\n                     let-index=\"index\">\n            <ng-container\n                *ngTemplateOutlet=\"optionTemplate; context: {item: item, item$: item$, index: index}\"></ng-container>\n        </ng-template>\n    }\n    @if (labelTemplate) {\n        <ng-template ng-label-tmp\n                     let-item=\"item\"\n                     let-item$=\"item$\"\n                     let-index=\"index\">\n            <ng-container\n                *ngTemplateOutlet=\"labelTemplate; context: {item: item, item$: item$, index: index}\"></ng-container>\n        </ng-template>\n    }\n    @if (multiLabelTemplate) {\n        <ng-template ng-multi-label-tmp\n                     let-items=\"items\"\n                     let-clear=\"clear\">\n            <ng-container *ngTemplateOutlet=\"multiLabelTemplate; context: {items: items, clear: clear}\"></ng-container>\n        </ng-template>\n    }\n    @if (optionGroupTemplate) {\n        <ng-template ng-optgroup-tmp\n                     let-item=\"item\"\n                     let-item$=\"item$\"\n                     let-index=\"index\">\n            <ng-container\n                *ngTemplateOutlet=\"optionGroupTemplate; context: {item: item, item$: item$, index: index}\"></ng-container>\n        </ng-template>\n    }\n</ng-select>\n\n@if (!hideErrors) {\n    <bb-form-error (errorChange)=\"onErrorChange($event)\"></bb-form-error>\n}\n\n<!-- The form control hint. -->\n@if (hint; as hintContent) {\n    <p class=\"bb-select-hint\">\n        <ng-template [bbTemplate]=\"hintContent\">{{ hintContent }}</ng-template>\n    </p>\n}\n", styles: [".bb-select{color:#2d3c4d;display:block;font-size:1rem}.bb-select.grouped{margin-bottom:1.5rem}.bb-select.required>.bb-select-label:after{content:\"*\";font-size:.75rem;vertical-align:top;color:var(--bb-form-label-required-color)}.bb-select.error>.bb-select-label{color:#c23934}.bb-select.error>.ng-select>.ng-select-container,.bb-select.error>.ng-select.ng-select-opened>.ng-select-container:hover{box-shadow:0 .375rem .375rem -.375rem #0000001a,0 0 0 .1875rem #f8d3d3}.bb-select.error>.ng-select>.ng-select-container{border:1px solid hsl(0,73%,30%);background-color:#f8d3d3}.bb-select.error>.ng-select>.ng-select-container>.ng-value-container>.ng-placeholder{color:#ea7b7b}.bb-select.readonly>.ng-select>.ng-select-container{cursor:default;border-style:dotted;border-color:#bdc4c9;color:#111;background-color:var(--bb-select-background-color)}.bb-select.hide-arrow .ng-arrow-wrapper{width:0;opacity:0;overflow:hidden;-webkit-user-select:none;user-select:none;pointer-events:none}.bb-select-label{display:block;margin-bottom:.25rem;color:var(--bb-form-label-color);font-size:var(--bb-form-label-font-size);font-weight:var(--bb-form-label-font-weight)}.bb-select-hint{display:block;line-height:1.5;margin-top:.25rem;font-size:.8125rem;color:#758795}.ng-select.ng-select-opened>.ng-select-container{background:var(--bb-select-background-color)}.ng-select.ng-select-opened>.ng-select-container:hover{box-shadow:var(--bb-select-box-shadow)}.ng-select.ng-select-opened>.ng-select-container .ng-arrow{top:-.125rem;border-width:0 .3125rem .3125rem;border-color:transparent transparent var(--bb-select-border-color)}.ng-select.ng-select-opened.ng-select-top>.ng-select-container{border-top-left-radius:0;border-top-right-radius:0}.ng-select.ng-select-opened.ng-select-right>.ng-select-container{border-top-right-radius:0;border-bottom-right-radius:0}.ng-select.ng-select-opened.ng-select-bottom>.ng-select-container{border-bottom-right-radius:0;border-bottom-left-radius:0}.ng-select.ng-select-opened.ng-select-left>.ng-select-container{border-top-left-radius:0;border-bottom-left-radius:0}.ng-select.ng-select-focused:not(.ng-select-opened)>.ng-select-container{border-color:#757e8a;box-shadow:var(--bb-select-focus-box-shadow)}.ng-select:has(.ng-input input:focus)>.ng-select-container{border-color:#757e8a;box-shadow:var(--bb-select-focus-box-shadow)}.ng-select.ng-select-disabled>.ng-select-container{color:gray;background-color:#e6e6e6}.ng-select .ng-has-value .ng-placeholder{display:none}.ng-select .ng-select-container{align-items:center;transition-duration:.25s;min-height:2.625rem;color:#111;background-color:var(--bb-select-background-color);box-shadow:var(--bb-select-box-shadow);border:1px solid var(--bb-select-border-color);border-radius:var(--bb-select-border-radius);transition-property:background-color,box-shadow;transition-timing-function:cubic-bezier(0,0,.2,1)}.ng-select .ng-select-container .ng-value-container{align-items:center;padding-left:.5rem}.ng-select .ng-select-container .ng-value-container .ng-placeholder{color:#d1d1d1}.ng-select.ng-select-single .ng-select-container{height:2.625rem}.ng-select.ng-select-single .ng-select-container .ng-value-container .ng-input{left:0;top:50%;padding-right:3.125rem;transform:translateY(-50%);padding-left:.5rem}.ng-select.ng-select-multiple.ng-select-disabled>.ng-select-container .ng-value-container .ng-value{border-radius:.25rem;border:1px solid var(--bb-select-border-color);background-color:#f9f9f9}.ng-select.ng-select-multiple.ng-select-disabled>.ng-select-container .ng-value-container .ng-value .ng-value-label{padding:0 .3125rem}.ng-select.ng-select-multiple .ng-select-container .ng-value-container{padding-top:.3125rem;padding-left:.4375rem}.ng-select.ng-select-multiple .ng-select-container .ng-value-container .ng-value{line-height:1.6;margin-right:.3125rem;border-radius:.125rem;margin-bottom:.3125rem;color:#111;font-size:1rem;background-color:#ebf5ff}.ng-select.ng-select-multiple .ng-select-container .ng-value-container .ng-value.ng-value-disabled{background-color:#f9f9f9}.ng-select.ng-select-multiple .ng-select-container .ng-value-container .ng-value.ng-value-disabled .ng-value-label{padding-left:.3125rem}.ng-select.ng-select-multiple .ng-select-container .ng-value-container .ng-value .ng-value-label,.ng-select.ng-select-multiple .ng-select-container .ng-value-container .ng-value .ng-value-icon{display:inline-block;padding:.0625rem .3125rem}.ng-select.ng-select-multiple .ng-select-container .ng-value-container .ng-value .ng-value-icon:hover{background-color:#d1e8ff}.ng-select.ng-select-multiple .ng-select-container .ng-value-container .ng-value .ng-value-icon.left{border-right:1px solid #b8dbff}.ng-select.ng-select-multiple .ng-select-container .ng-value-container .ng-value .ng-value-icon.right{border-left:1px solid #b8dbff}.ng-select.ng-select-multiple .ng-select-container .ng-value-container .ng-input{padding:0 0 .1875rem .1875rem}.ng-select.ng-select-multiple .ng-select-container .ng-value-container .ng-input>input{color:#111}.ng-select.ng-select-multiple .ng-select-container .ng-value-container .ng-placeholder{padding-left:.1875rem;padding-bottom:.3125rem}.ng-select .ng-clear-wrapper{margin-left:.5rem;color:var(--bb-select-border-color)}.ng-select .ng-clear-wrapper:hover .ng-clear{color:#d0021b}.ng-select .ng-clear-wrapper:focus .ng-clear{color:#d0021b}.ng-select .ng-clear-wrapper:focus{outline:none}.ng-select .ng-spinner-zone{padding:.3125rem .3125rem 0 0}.ng-select .ng-arrow-wrapper{width:1.5625rem;padding-right:.3125rem}.ng-select .ng-arrow-wrapper .ng-arrow{border-style:solid;border-width:.3125rem .3125rem .15625rem;border-color:var(--bb-select-border-color) transparent transparent}.ng-dropdown-panel{left:0;overflow:hidden;box-shadow:0 1px #0000000f;background-color:var(--bb-select-background-color);border:1px solid var(--bb-select-border-color)}.ng-dropdown-panel.ng-select-top{bottom:100%;margin-bottom:-1px;border-bottom-color:var(--bb-select-border-color);border-top-left-radius:var(--bb-select-border-radius);border-top-right-radius:var(--bb-select-border-radius)}.ng-dropdown-panel.ng-select-top .ng-dropdown-panel-items .ng-option:first-child{border-top-left-radius:var(--bb-select-border-radius);border-top-right-radius:var(--bb-select-border-radius)}.ng-dropdown-panel.ng-select-right{top:0;left:100%;margin-bottom:-1px;border-bottom-color:var(--bb-select-border-color);border-top-right-radius:var(--bb-select-border-radius);border-bottom-left-radius:var(--bb-select-border-radius);border-bottom-right-radius:var(--bb-select-border-radius)}.ng-dropdown-panel.ng-select-right .ng-dropdown-panel-items .ng-option:first-child{border-top-right-radius:var(--bb-select-border-radius)}.ng-dropdown-panel.ng-select-bottom{top:100%;margin-top:-1px;border-top-color:var(--bb-select-border-color);border-bottom-left-radius:var(--bb-select-border-radius);border-bottom-right-radius:var(--bb-select-border-radius)}.ng-dropdown-panel.ng-select-bottom .ng-dropdown-panel-items .ng-option:last-child{border-bottom-left-radius:var(--bb-select-border-radius);border-bottom-right-radius:var(--bb-select-border-radius)}.ng-dropdown-panel.ng-select-left{top:0;left:-100%;margin-bottom:-1px;border-bottom-color:var(--bb-select-border-color);border-top-left-radius:var(--bb-select-border-radius);border-bottom-left-radius:var(--bb-select-border-radius);border-bottom-right-radius:var(--bb-select-border-radius)}.ng-dropdown-panel.ng-select-left .ng-dropdown-panel-items .ng-option:first-child{border-top-left-radius:var(--bb-select-border-radius)}.ng-dropdown-panel .ng-dropdown-header{padding:.3125rem .4375rem;border-bottom:1px solid var(--bb-select-border-color)}.ng-dropdown-panel .ng-dropdown-footer{padding:.3125rem .4375rem;border-top:1px solid var(--bb-select-border-color)}.ng-dropdown-panel .ng-dropdown-panel-items .ng-optgroup{cursor:pointer;font-weight:500;-webkit-user-select:none;user-select:none;padding:.5rem .625rem;color:#0000008a}.ng-dropdown-panel .ng-dropdown-panel-items .ng-optgroup.ng-option-disabled{cursor:default}.ng-dropdown-panel .ng-dropdown-panel-items .ng-optgroup.ng-option-marked{background-color:#f5faff}.ng-dropdown-panel .ng-dropdown-panel-items .ng-optgroup.ng-option-selected,.ng-dropdown-panel .ng-dropdown-panel-items .ng-optgroup.ng-option-selected.ng-option-marked{font-weight:500;background-color:#ebf5ff;color:#0000008a}.ng-dropdown-panel .ng-dropdown-panel-items .ng-option{font-size:1rem;font-weight:400;padding:.5rem .625rem;color:#000000de;background-color:var(--bb-select-background-color)}.ng-dropdown-panel .ng-dropdown-panel-items .ng-option.ng-option-selected,.ng-dropdown-panel .ng-dropdown-panel-items .ng-option.ng-option-selected.ng-option-marked{color:#111;background-color:#ebf5ff}.ng-dropdown-panel .ng-dropdown-panel-items .ng-option.ng-option-selected .ng-option-label,.ng-dropdown-panel .ng-dropdown-panel-items .ng-option.ng-option-selected.ng-option-marked .ng-option-label{font-weight:500}.ng-dropdown-panel .ng-dropdown-panel-items .ng-option.ng-option-marked{color:#111;background-color:#f5faff}.ng-dropdown-panel .ng-dropdown-panel-items .ng-option.ng-option-disabled{color:#aaa}.ng-dropdown-panel .ng-dropdown-panel-items .ng-option.ng-option-child{padding-left:1.375rem}.ng-dropdown-panel .ng-dropdown-panel-items .ng-option .ng-tag-label{font-size:80%;font-weight:400;padding-right:.3125rem}\n"], dependencies: [{ kind: "ngmodule", type: ReactiveFormsModule }, { kind: "directive", type: i1.NgControlStatus, selector: "[formControlName],[ngModel],[formControl]" }, { kind: "directive", type: i1.FormControlDirective, selector: "[formControl]", inputs: ["formControl", "disabled", "ngModel"], outputs: ["ngModelChange"], exportAs: ["ngForm"] }, { kind: "pipe", type: AsyncPipe, name: "async" }, { kind: "directive", type: NgTemplateOutlet, selector: "[ngTemplateOutlet]", inputs: ["ngTemplateOutletContext", "ngTemplateOutlet", "ngTemplateOutletInjector"] }, { kind: "directive", type: BbTemplate, selector: "[bbTemplate]", inputs: ["bbTemplate"] }, { kind: "component", type: BbFormError, selector: "bb-form-error", inputs: ["control"], outputs: ["errorChange"] }, { kind: "pipe", type: BbLocalize, name: "bbLocalize" }, { kind: "component", type: NgSelectComponent, selector: "ng-select", inputs: ["bindLabel", "bindValue", "ariaLabel", "markFirst", "placeholder", "fixedPlaceholder", "notFoundText", "typeToSearchText", "preventToggleOnRightClick", "addTagText", "loadingText", "clearAllText", "appearance", "dropdownPosition", "appendTo", "loading", "closeOnSelect", "hideSelected", "selectOnTab", "openOnEnter", "maxSelectedItems", "groupBy", "groupValue", "bufferAmount", "virtualScroll", "selectableGroup", "selectableGroupAsModel", "searchFn", "trackByFn", "clearOnBackspace", "labelForId", "inputAttrs", "tabIndex", "readonly", "searchWhileComposing", "minTermLength", "editableSearchTerm", "ngClass", "typeahead", "multiple", "addTag", "searchable", "clearable", "isOpen", "items", "compareWith", "clearSearchOnAdd", "deselectOnClick", "keyDownFn"], outputs: ["blur", "focus", "change", "open", "close", "search", "clear", "add", "remove", "scroll", "scrollToEnd"] }, { kind: "directive", type: NgOptionTemplateDirective, selector: "[ng-option-tmp]" }, { kind: "directive", type: NgLabelTemplateDirective, selector: "[ng-label-tmp]" }, { kind: "directive", type: NgMultiLabelTemplateDirective, selector: "[ng-multi-label-tmp]" }, { kind: "directive", type: NgOptgroupTemplateDirective, selector: "[ng-optgroup-tmp]" }], changeDetection: i0.ChangeDetectionStrategy.OnPush, encapsulation: i0.ViewEncapsulation.None });
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "18.2.8", ngImport: i0, type: BbSelect, decorators: [{
            type: Component,
            args: [{ selector: 'bb-select', changeDetection: ChangeDetectionStrategy.OnPush, encapsulation: ViewEncapsulation.None, providers: [{
                            provide: NG_VALUE_ACCESSOR,
                            useExisting: forwardRef(() => BbSelect),
                            multi: true
                        }], host: {
                        'class': 'bb-select',
                        '[class.required]': 'required',
                        '[class.readonly]': 'readonly',
                        '[class.disabled]': 'disabled',
                        '[class.grouped]': 'grouped',
                        '[class.error]': 'error',
                        '[class.hide-arrow]': 'hideArrow'
                    }, preserveWhitespaces: false, standalone: true, imports: [
                        ReactiveFormsModule,
                        AsyncPipe,
                        NgTemplateOutlet,
                        BbTemplate,
                        BbFormError,
                        BbLocalize,
                        NgSelectComponent,
                        NgOptionTemplateDirective,
                        NgLabelTemplateDirective,
                        NgMultiLabelTemplateDirective,
                        NgOptgroupTemplateDirective
                    ], template: "<!-- Label of the form control. -->\n@if (label; as labelContent) {\n    <label [attr.for]=\"labelId\"\n           class=\"bb-select-label\">\n        <ng-template [bbTemplate]=\"labelContent\">{{ labelContent }}</ng-template>\n    </label>\n}\n\n<ng-select [formControl]=\"control\"\n           [notFoundText]=\"'select.not_found_text' | bbLocalize\"\n           [clearAllText]=\"'select.clear_all_text' | bbLocalize\"\n           [loadingText]=\"'select.loading_text' | bbLocalize\"\n           [typeToSearchText]=\"'select.type_to_search_text' | bbLocalize\"\n           [addTagText]=\"'select.add_tag_text' | bbLocalize\"\n           [virtualScroll]=\"virtualScroll\"\n           [items]=\"data | async\"\n           [multiple]=\"multiple\"\n           [loading]=\"loading\"\n           [labelForId]=\"labelId\"\n           [searchable]=\"searchable\"\n           [placeholder]=\"placeholder\"\n           [clearable]=\"clearable\"\n           [closeOnSelect]=\"closeOnSelect\"\n           [trackByFn]=\"trackByFn\"\n           [typeahead]=\"typeahead\"\n           [bindLabel]=\"bindLabel\"\n           [bindValue]=\"bindValue\"\n           [selectableGroup]=\"selectableGroup\"\n           [selectableGroupAsModel]=\"selectableGroupAsModel\"\n           [clearSearchOnAdd]=\"clearSearchOnAdd\"\n           [hideSelected]=\"hideSelected\"\n           [maxSelectedItems]=\"maxSelectedItems\"\n           [groupBy]=\"groupBy\"\n           [isOpen]=\"isOpen\"\n           [readonly]=\"readonly\"\n           [addTag]=\"addTag\"\n           [appendTo]=\"appendTo\"\n           (blur)=\"onBlur?.emit($event)\"\n           (change)=\"onChange?.emit($event)\">\n    @if (optionTemplate) {\n        <ng-template ng-option-tmp\n                     let-item=\"item\"\n                     let-item$=\"item$\"\n                     let-index=\"index\">\n            <ng-container\n                *ngTemplateOutlet=\"optionTemplate; context: {item: item, item$: item$, index: index}\"></ng-container>\n        </ng-template>\n    }\n    @if (labelTemplate) {\n        <ng-template ng-label-tmp\n                     let-item=\"item\"\n                     let-item$=\"item$\"\n                     let-index=\"index\">\n            <ng-container\n                *ngTemplateOutlet=\"labelTemplate; context: {item: item, item$: item$, index: index}\"></ng-container>\n        </ng-template>\n    }\n    @if (multiLabelTemplate) {\n        <ng-template ng-multi-label-tmp\n                     let-items=\"items\"\n                     let-clear=\"clear\">\n            <ng-container *ngTemplateOutlet=\"multiLabelTemplate; context: {items: items, clear: clear}\"></ng-container>\n        </ng-template>\n    }\n    @if (optionGroupTemplate) {\n        <ng-template ng-optgroup-tmp\n                     let-item=\"item\"\n                     let-item$=\"item$\"\n                     let-index=\"index\">\n            <ng-container\n                *ngTemplateOutlet=\"optionGroupTemplate; context: {item: item, item$: item$, index: index}\"></ng-container>\n        </ng-template>\n    }\n</ng-select>\n\n@if (!hideErrors) {\n    <bb-form-error (errorChange)=\"onErrorChange($event)\"></bb-form-error>\n}\n\n<!-- The form control hint. -->\n@if (hint; as hintContent) {\n    <p class=\"bb-select-hint\">\n        <ng-template [bbTemplate]=\"hintContent\">{{ hintContent }}</ng-template>\n    </p>\n}\n", styles: [".bb-select{color:#2d3c4d;display:block;font-size:1rem}.bb-select.grouped{margin-bottom:1.5rem}.bb-select.required>.bb-select-label:after{content:\"*\";font-size:.75rem;vertical-align:top;color:var(--bb-form-label-required-color)}.bb-select.error>.bb-select-label{color:#c23934}.bb-select.error>.ng-select>.ng-select-container,.bb-select.error>.ng-select.ng-select-opened>.ng-select-container:hover{box-shadow:0 .375rem .375rem -.375rem #0000001a,0 0 0 .1875rem #f8d3d3}.bb-select.error>.ng-select>.ng-select-container{border:1px solid hsl(0,73%,30%);background-color:#f8d3d3}.bb-select.error>.ng-select>.ng-select-container>.ng-value-container>.ng-placeholder{color:#ea7b7b}.bb-select.readonly>.ng-select>.ng-select-container{cursor:default;border-style:dotted;border-color:#bdc4c9;color:#111;background-color:var(--bb-select-background-color)}.bb-select.hide-arrow .ng-arrow-wrapper{width:0;opacity:0;overflow:hidden;-webkit-user-select:none;user-select:none;pointer-events:none}.bb-select-label{display:block;margin-bottom:.25rem;color:var(--bb-form-label-color);font-size:var(--bb-form-label-font-size);font-weight:var(--bb-form-label-font-weight)}.bb-select-hint{display:block;line-height:1.5;margin-top:.25rem;font-size:.8125rem;color:#758795}.ng-select.ng-select-opened>.ng-select-container{background:var(--bb-select-background-color)}.ng-select.ng-select-opened>.ng-select-container:hover{box-shadow:var(--bb-select-box-shadow)}.ng-select.ng-select-opened>.ng-select-container .ng-arrow{top:-.125rem;border-width:0 .3125rem .3125rem;border-color:transparent transparent var(--bb-select-border-color)}.ng-select.ng-select-opened.ng-select-top>.ng-select-container{border-top-left-radius:0;border-top-right-radius:0}.ng-select.ng-select-opened.ng-select-right>.ng-select-container{border-top-right-radius:0;border-bottom-right-radius:0}.ng-select.ng-select-opened.ng-select-bottom>.ng-select-container{border-bottom-right-radius:0;border-bottom-left-radius:0}.ng-select.ng-select-opened.ng-select-left>.ng-select-container{border-top-left-radius:0;border-bottom-left-radius:0}.ng-select.ng-select-focused:not(.ng-select-opened)>.ng-select-container{border-color:#757e8a;box-shadow:var(--bb-select-focus-box-shadow)}.ng-select:has(.ng-input input:focus)>.ng-select-container{border-color:#757e8a;box-shadow:var(--bb-select-focus-box-shadow)}.ng-select.ng-select-disabled>.ng-select-container{color:gray;background-color:#e6e6e6}.ng-select .ng-has-value .ng-placeholder{display:none}.ng-select .ng-select-container{align-items:center;transition-duration:.25s;min-height:2.625rem;color:#111;background-color:var(--bb-select-background-color);box-shadow:var(--bb-select-box-shadow);border:1px solid var(--bb-select-border-color);border-radius:var(--bb-select-border-radius);transition-property:background-color,box-shadow;transition-timing-function:cubic-bezier(0,0,.2,1)}.ng-select .ng-select-container .ng-value-container{align-items:center;padding-left:.5rem}.ng-select .ng-select-container .ng-value-container .ng-placeholder{color:#d1d1d1}.ng-select.ng-select-single .ng-select-container{height:2.625rem}.ng-select.ng-select-single .ng-select-container .ng-value-container .ng-input{left:0;top:50%;padding-right:3.125rem;transform:translateY(-50%);padding-left:.5rem}.ng-select.ng-select-multiple.ng-select-disabled>.ng-select-container .ng-value-container .ng-value{border-radius:.25rem;border:1px solid var(--bb-select-border-color);background-color:#f9f9f9}.ng-select.ng-select-multiple.ng-select-disabled>.ng-select-container .ng-value-container .ng-value .ng-value-label{padding:0 .3125rem}.ng-select.ng-select-multiple .ng-select-container .ng-value-container{padding-top:.3125rem;padding-left:.4375rem}.ng-select.ng-select-multiple .ng-select-container .ng-value-container .ng-value{line-height:1.6;margin-right:.3125rem;border-radius:.125rem;margin-bottom:.3125rem;color:#111;font-size:1rem;background-color:#ebf5ff}.ng-select.ng-select-multiple .ng-select-container .ng-value-container .ng-value.ng-value-disabled{background-color:#f9f9f9}.ng-select.ng-select-multiple .ng-select-container .ng-value-container .ng-value.ng-value-disabled .ng-value-label{padding-left:.3125rem}.ng-select.ng-select-multiple .ng-select-container .ng-value-container .ng-value .ng-value-label,.ng-select.ng-select-multiple .ng-select-container .ng-value-container .ng-value .ng-value-icon{display:inline-block;padding:.0625rem .3125rem}.ng-select.ng-select-multiple .ng-select-container .ng-value-container .ng-value .ng-value-icon:hover{background-color:#d1e8ff}.ng-select.ng-select-multiple .ng-select-container .ng-value-container .ng-value .ng-value-icon.left{border-right:1px solid #b8dbff}.ng-select.ng-select-multiple .ng-select-container .ng-value-container .ng-value .ng-value-icon.right{border-left:1px solid #b8dbff}.ng-select.ng-select-multiple .ng-select-container .ng-value-container .ng-input{padding:0 0 .1875rem .1875rem}.ng-select.ng-select-multiple .ng-select-container .ng-value-container .ng-input>input{color:#111}.ng-select.ng-select-multiple .ng-select-container .ng-value-container .ng-placeholder{padding-left:.1875rem;padding-bottom:.3125rem}.ng-select .ng-clear-wrapper{margin-left:.5rem;color:var(--bb-select-border-color)}.ng-select .ng-clear-wrapper:hover .ng-clear{color:#d0021b}.ng-select .ng-clear-wrapper:focus .ng-clear{color:#d0021b}.ng-select .ng-clear-wrapper:focus{outline:none}.ng-select .ng-spinner-zone{padding:.3125rem .3125rem 0 0}.ng-select .ng-arrow-wrapper{width:1.5625rem;padding-right:.3125rem}.ng-select .ng-arrow-wrapper .ng-arrow{border-style:solid;border-width:.3125rem .3125rem .15625rem;border-color:var(--bb-select-border-color) transparent transparent}.ng-dropdown-panel{left:0;overflow:hidden;box-shadow:0 1px #0000000f;background-color:var(--bb-select-background-color);border:1px solid var(--bb-select-border-color)}.ng-dropdown-panel.ng-select-top{bottom:100%;margin-bottom:-1px;border-bottom-color:var(--bb-select-border-color);border-top-left-radius:var(--bb-select-border-radius);border-top-right-radius:var(--bb-select-border-radius)}.ng-dropdown-panel.ng-select-top .ng-dropdown-panel-items .ng-option:first-child{border-top-left-radius:var(--bb-select-border-radius);border-top-right-radius:var(--bb-select-border-radius)}.ng-dropdown-panel.ng-select-right{top:0;left:100%;margin-bottom:-1px;border-bottom-color:var(--bb-select-border-color);border-top-right-radius:var(--bb-select-border-radius);border-bottom-left-radius:var(--bb-select-border-radius);border-bottom-right-radius:var(--bb-select-border-radius)}.ng-dropdown-panel.ng-select-right .ng-dropdown-panel-items .ng-option:first-child{border-top-right-radius:var(--bb-select-border-radius)}.ng-dropdown-panel.ng-select-bottom{top:100%;margin-top:-1px;border-top-color:var(--bb-select-border-color);border-bottom-left-radius:var(--bb-select-border-radius);border-bottom-right-radius:var(--bb-select-border-radius)}.ng-dropdown-panel.ng-select-bottom .ng-dropdown-panel-items .ng-option:last-child{border-bottom-left-radius:var(--bb-select-border-radius);border-bottom-right-radius:var(--bb-select-border-radius)}.ng-dropdown-panel.ng-select-left{top:0;left:-100%;margin-bottom:-1px;border-bottom-color:var(--bb-select-border-color);border-top-left-radius:var(--bb-select-border-radius);border-bottom-left-radius:var(--bb-select-border-radius);border-bottom-right-radius:var(--bb-select-border-radius)}.ng-dropdown-panel.ng-select-left .ng-dropdown-panel-items .ng-option:first-child{border-top-left-radius:var(--bb-select-border-radius)}.ng-dropdown-panel .ng-dropdown-header{padding:.3125rem .4375rem;border-bottom:1px solid var(--bb-select-border-color)}.ng-dropdown-panel .ng-dropdown-footer{padding:.3125rem .4375rem;border-top:1px solid var(--bb-select-border-color)}.ng-dropdown-panel .ng-dropdown-panel-items .ng-optgroup{cursor:pointer;font-weight:500;-webkit-user-select:none;user-select:none;padding:.5rem .625rem;color:#0000008a}.ng-dropdown-panel .ng-dropdown-panel-items .ng-optgroup.ng-option-disabled{cursor:default}.ng-dropdown-panel .ng-dropdown-panel-items .ng-optgroup.ng-option-marked{background-color:#f5faff}.ng-dropdown-panel .ng-dropdown-panel-items .ng-optgroup.ng-option-selected,.ng-dropdown-panel .ng-dropdown-panel-items .ng-optgroup.ng-option-selected.ng-option-marked{font-weight:500;background-color:#ebf5ff;color:#0000008a}.ng-dropdown-panel .ng-dropdown-panel-items .ng-option{font-size:1rem;font-weight:400;padding:.5rem .625rem;color:#000000de;background-color:var(--bb-select-background-color)}.ng-dropdown-panel .ng-dropdown-panel-items .ng-option.ng-option-selected,.ng-dropdown-panel .ng-dropdown-panel-items .ng-option.ng-option-selected.ng-option-marked{color:#111;background-color:#ebf5ff}.ng-dropdown-panel .ng-dropdown-panel-items .ng-option.ng-option-selected .ng-option-label,.ng-dropdown-panel .ng-dropdown-panel-items .ng-option.ng-option-selected.ng-option-marked .ng-option-label{font-weight:500}.ng-dropdown-panel .ng-dropdown-panel-items .ng-option.ng-option-marked{color:#111;background-color:#f5faff}.ng-dropdown-panel .ng-dropdown-panel-items .ng-option.ng-option-disabled{color:#aaa}.ng-dropdown-panel .ng-dropdown-panel-items .ng-option.ng-option-child{padding-left:1.375rem}.ng-dropdown-panel .ng-dropdown-panel-items .ng-option .ng-tag-label{font-size:80%;font-weight:400;padding-right:.3125rem}\n"] }]
        }], propDecorators: { optionTemplate: [{
                type: ContentChild,
                args: [BbSelectOption, { read: TemplateRef }]
            }], optionGroupTemplate: [{
                type: ContentChild,
                args: [BbSelectOptionGroup, { read: TemplateRef }]
            }], labelTemplate: [{
                type: ContentChild,
                args: [BbSelectLabel, { read: TemplateRef }]
            }], multiLabelTemplate: [{
                type: ContentChild,
                args: [BbSelectMultiLabel, { read: TemplateRef }]
            }], selectComponent: [{
                type: ViewChild,
                args: [NgSelectComponent, { static: true }]
            }], label: [{
                type: Input
            }], hint: [{
                type: Input
            }], data: [{
                type: Input,
                args: [{ transform: observableAttribute }]
            }], required: [{
                type: Input,
                args: [{ transform: booleanAttribute }]
            }], readonly: [{
                type: Input,
                args: [{ transform: booleanAttribute }]
            }], grouped: [{
                type: Input,
                args: [{ transform: booleanAttribute }]
            }], hideErrors: [{
                type: Input,
                args: [{ transform: booleanAttribute }]
            }], loading: [{
                type: Input,
                args: [{ transform: booleanAttribute }]
            }], multiple: [{
                type: Input,
                args: [{ transform: booleanAttribute }]
            }], clearable: [{
                type: Input,
                args: [{ transform: booleanAttribute }]
            }], searchable: [{
                type: Input,
                args: [{ transform: booleanAttribute }]
            }], virtualScroll: [{
                type: Input,
                args: [{ transform: booleanAttribute }]
            }], closeOnSelect: [{
                type: Input,
                args: [{ transform: booleanAttribute }]
            }], selectableGroup: [{
                type: Input,
                args: [{ transform: booleanAttribute }]
            }], selectableGroupAsModel: [{
                type: Input,
                args: [{ transform: booleanAttribute }]
            }], hideArrow: [{
                type: Input,
                args: [{ transform: booleanAttribute }]
            }], selectOnTab: [{
                type: Input,
                args: [{ transform: booleanAttribute }]
            }], hideSelected: [{
                type: Input,
                args: [{ transform: booleanAttribute }]
            }], maxSelectedItems: [{
                type: Input,
                args: [{ transform: numberAttribute }]
            }], bindLabel: [{
                type: Input
            }], bindValue: [{
                type: Input
            }], placeholder: [{
                type: Input
            }], typeahead: [{
                type: Input
            }], trackByFn: [{
                type: Input
            }], groupBy: [{
                type: Input
            }], isOpen: [{
                type: Input
            }], clearSearchOnAdd: [{
                type: Input
            }], addTag: [{
                type: Input
            }], appendTo: [{
                type: Input
            }], disabled: [{
                type: Input,
                args: [{ transform: booleanAttribute }]
            }], value: [{
                type: Input
            }], valueChange: [{
                type: Output
            }], onBlur: [{
                type: Output
            }], onChange: [{
                type: Output
            }] } });

function provideSelectConfig() {
    return makeEnvironmentProviders([
        { provide: SELECTION_MODEL_FACTORY, useValue: DefaultSelectionModelFactory }
    ]);
}

class SelectModule {
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "18.2.8", ngImport: i0, type: SelectModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
    static ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "18.2.8", ngImport: i0, type: SelectModule, imports: [BbSelect,
            BbSelectLabel,
            BbSelectOption,
            BbSelectOptionGroup,
            BbSelectMultiLabel], exports: [BbSelect,
            BbSelectLabel,
            BbSelectOption,
            BbSelectOptionGroup,
            BbSelectMultiLabel] });
    static ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "18.2.8", ngImport: i0, type: SelectModule, providers: [
            provideSelectConfig()
        ], imports: [BbSelect] });
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "18.2.8", ngImport: i0, type: SelectModule, decorators: [{
            type: NgModule,
            args: [{
                    imports: [
                        BbSelect,
                        BbSelectLabel,
                        BbSelectOption,
                        BbSelectOptionGroup,
                        BbSelectMultiLabel
                    ],
                    exports: [
                        BbSelect,
                        BbSelectLabel,
                        BbSelectOption,
                        BbSelectOptionGroup,
                        BbSelectMultiLabel
                    ],
                    providers: [
                        provideSelectConfig()
                    ]
                }]
        }] });

/**
 * Generated bundle index. Do not edit.
 */

export { BbSelect, BbSelectLabel, BbSelectMultiLabel, BbSelectOption, BbSelectOptionGroup, SelectModule, provideSelectConfig };
//# sourceMappingURL=bravobit-bb-foundation-select.mjs.map
