import { HttpConfig } from './classes/http.config';
import { InjectionToken } from '@angular/core';
export interface HttpConfigData {
    url: HttpConfigUrl;
    alias?: {
        prefix?: string;
        standard?: string;
    };
    disableErrorParsing?: boolean;
}
export type HttpConfigPlatformUrl = string | {
    browser: string;
    server: string;
};
export type HttpConfigAlias = {
    alias: string;
    url: HttpConfigPlatformUrl;
};
export type HttpConfigUrl = HttpConfigPlatformUrl | HttpConfigAlias[];
export declare const HTTP_CONFIG: InjectionToken<HttpConfig>;
export declare const HTTP_CONFIG_DATA: InjectionToken<HttpConfigData>;
