import { LocalizeConfigLanguage } from './interfaces/config.interfaces';
import { LocalizeDictionary } from './dictionary/dictionary.class';
import { LocalizeParams } from './interfaces/options.interfaces';
import * as i0 from "@angular/core";
export declare class Localize {
    private readonly _storage;
    private readonly _languages;
    private readonly _window?;
    private readonly _document?;
    private readonly _config?;
    private readonly _transforms?;
    private readonly _missingHandler?;
    private readonly _storageToken;
    private readonly _availableLanguages;
    private readonly _bestMatchingLanguage;
    private readonly _loadedDictionaries;
    private _current$;
    dictionaryChanges$: import("rxjs").Observable<LocalizeDictionary>;
    constructor();
    get languages(): LocalizeConfigLanguage[];
    get current(): LocalizeDictionary;
    load(id: string): any;
    loadAllLanguages(): Promise<void>;
    switch(id: string, options?: {
        cache?: boolean;
        reload?: boolean;
    }): Promise<any>;
    select(id: string): LocalizeDictionary;
    initialize(): () => Promise<void>;
    clear(): void;
    transform(value: string, data?: LocalizeParams['data']): string;
    translate(tokenOrParams: string | LocalizeParams): string;
    private retrieveBestMatchingLanguage;
    private getLanguageFromStorage;
    private getBestBrowserMatchLanguage;
    private createDictionary;
    private getDictionary;
    private renderDocumentLanguage;
    private compareDictionaries;
    private convertToParams;
    static ɵfac: i0.ɵɵFactoryDeclaration<Localize, never>;
    static ɵprov: i0.ɵɵInjectableDeclaration<Localize>;
}
