import { EventEmitter, OnDestroy, OnInit, TemplateRef } from '@angular/core';
import { NgSelectComponent } from '@ng-select/ng-select';
import { ControlValueAccessor, FormControl } from '@angular/forms';
import { Observable, Subject } from 'rxjs';
import * as i0 from "@angular/core";
export declare class BbSelect<T> implements ControlValueAccessor, OnInit, OnDestroy {
    readonly labelId: string;
    readonly control: FormControl<any>;
    optionTemplate: TemplateRef<any>;
    optionGroupTemplate: TemplateRef<any>;
    labelTemplate: TemplateRef<any>;
    multiLabelTemplate: TemplateRef<any>;
    selectComponent: NgSelectComponent;
    label: string | TemplateRef<any> | null;
    hint: string | TemplateRef<any> | null;
    data: Observable<T[]> | null;
    required: boolean;
    readonly: boolean;
    grouped: boolean;
    hideErrors: boolean;
    loading: boolean;
    multiple: boolean;
    clearable: boolean;
    searchable: boolean;
    virtualScroll: boolean;
    closeOnSelect: boolean;
    selectableGroup: boolean;
    selectableGroupAsModel: boolean;
    hideArrow: boolean;
    selectOnTab: boolean;
    hideSelected: boolean;
    maxSelectedItems: number | null;
    bindLabel: string | null;
    bindValue: string | null;
    placeholder: string | null;
    typeahead: Subject<string> | null;
    trackByFn: any | null;
    groupBy: string | null;
    isOpen: boolean;
    clearSearchOnAdd: boolean;
    addTag: boolean | ((term: string) => any | Promise<any>);
    appendTo: string | null;
    set disabled(value: boolean);
    get disabled(): boolean;
    get value(): any | null;
    valueChange: EventEmitter<any>;
    onBlur: EventEmitter<FocusEvent>;
    onChange: EventEmitter<any>;
    set value(value: any | null);
    error: boolean;
    private _disabled;
    onTouchedCallback: () => void;
    onChangeCallback: (_: T | null) => void;
    private _subscription;
    ngOnInit(): void;
    ngOnDestroy(): void;
    writeValue(value: T | null): void;
    registerOnChange(method: (_: T | null) => void): void;
    registerOnTouched(method: () => void): void;
    setDisabledState(isDisabled: boolean): void;
    onErrorChange(error: {
        token: string;
        data?: any;
    } | null): void;
    private handleValueChanges;
    static ɵfac: i0.ɵɵFactoryDeclaration<BbSelect<any>, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<BbSelect<any>, "bb-select", never, { "label": { "alias": "label"; "required": false; }; "hint": { "alias": "hint"; "required": false; }; "data": { "alias": "data"; "required": false; }; "required": { "alias": "required"; "required": false; }; "readonly": { "alias": "readonly"; "required": false; }; "grouped": { "alias": "grouped"; "required": false; }; "hideErrors": { "alias": "hideErrors"; "required": false; }; "loading": { "alias": "loading"; "required": false; }; "multiple": { "alias": "multiple"; "required": false; }; "clearable": { "alias": "clearable"; "required": false; }; "searchable": { "alias": "searchable"; "required": false; }; "virtualScroll": { "alias": "virtualScroll"; "required": false; }; "closeOnSelect": { "alias": "closeOnSelect"; "required": false; }; "selectableGroup": { "alias": "selectableGroup"; "required": false; }; "selectableGroupAsModel": { "alias": "selectableGroupAsModel"; "required": false; }; "hideArrow": { "alias": "hideArrow"; "required": false; }; "selectOnTab": { "alias": "selectOnTab"; "required": false; }; "hideSelected": { "alias": "hideSelected"; "required": false; }; "maxSelectedItems": { "alias": "maxSelectedItems"; "required": false; }; "bindLabel": { "alias": "bindLabel"; "required": false; }; "bindValue": { "alias": "bindValue"; "required": false; }; "placeholder": { "alias": "placeholder"; "required": false; }; "typeahead": { "alias": "typeahead"; "required": false; }; "trackByFn": { "alias": "trackByFn"; "required": false; }; "groupBy": { "alias": "groupBy"; "required": false; }; "isOpen": { "alias": "isOpen"; "required": false; }; "clearSearchOnAdd": { "alias": "clearSearchOnAdd"; "required": false; }; "addTag": { "alias": "addTag"; "required": false; }; "appendTo": { "alias": "appendTo"; "required": false; }; "disabled": { "alias": "disabled"; "required": false; }; "value": { "alias": "value"; "required": false; }; }, { "valueChange": "valueChange"; "onBlur": "onBlur"; "onChange": "onChange"; }, ["optionTemplate", "optionGroupTemplate", "labelTemplate", "multiLabelTemplate"], never, true, never>;
    static ngAcceptInputType_data: unknown;
    static ngAcceptInputType_required: unknown;
    static ngAcceptInputType_readonly: unknown;
    static ngAcceptInputType_grouped: unknown;
    static ngAcceptInputType_hideErrors: unknown;
    static ngAcceptInputType_loading: unknown;
    static ngAcceptInputType_multiple: unknown;
    static ngAcceptInputType_clearable: unknown;
    static ngAcceptInputType_searchable: unknown;
    static ngAcceptInputType_virtualScroll: unknown;
    static ngAcceptInputType_closeOnSelect: unknown;
    static ngAcceptInputType_selectableGroup: unknown;
    static ngAcceptInputType_selectableGroupAsModel: unknown;
    static ngAcceptInputType_hideArrow: unknown;
    static ngAcceptInputType_selectOnTab: unknown;
    static ngAcceptInputType_hideSelected: unknown;
    static ngAcceptInputType_maxSelectedItems: unknown;
    static ngAcceptInputType_disabled: unknown;
}
